10 Constant Height
10 Constant Width
1  Constant W \ Wall
2  Constant E \ Eat
0  Constant X \ Empty

66 Constant DefaultDelay

5 Constant StartLives

10 Constant PacStartX
10 Constant PacStartY
80 Constant BotStartX
80 Constant BotStartY

256 Constant max-line

0 Value fd-in

variable opxt \ XT of operation

: createVar ( "name" -- a-addr )
	create 0 ,
;

: two-dim-array \ (x y -- addr) \ n1 n2 -- ; [child] n1 n2 -- addr 
	Create                   \ create data word
		Over ,                 \   save width for run-time
		cell * *               \   calculate size
		Here over erase        \   clear memory
		allot                  \   reserve n cells
	Does>                    \ run time gives address of data
		Dup @ Rot * Rot + 1+
		cell *
		+
;

createVar PacX
createVar PacY
createVar PacDir
createVar PacWish
PacStartX PacX !
PacStartY PacY !


createVar BotX
createVar BotY
createVar BotDir
2 BotDir !
BotStartX BotX !
BotStartY BotY !

createVar MovX
createVar MovY

createVar Delay
DefaultDelay Delay !

createVar Lives
StartLives Lives !

Create line-buffer  max-line 2 + allot

createVar count \ count of eat
createVar MaxCount \ count of maximum eat

Height Width two-dim-array World
